View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.statemachine.context;
    21
    22  import org.apache.mina.statemachine.State;
    23  import org.apache.mina.statemachine.StateMachine;
    24
    25  /**
    26   * {@link StateContext} objects are used to store the current {@link State} and
    27   * any application specific attributes for a specific client of a
    28   * {@link StateMachine}. Since {@link StateMachine}s are singletons and shared
    29   * by all clients using the {@link StateMachine} this is where client specific
    30   * data needs to be stored.
    31   *
    32   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    33   */
    34  public interface StateContext {
    35      /**
    36       * Returns the current {@link State}. This is only meant for internal use.
    37       *
    38       * @return the current {@link State}.
    39       */
    40      State getCurrentState();
    41
    42      /**
    43       * Sets the current {@link State}. This is only meant for internal use.
    44       * Don't call it directly!
    45       *
    46       * @param state the new current {@link State}.
    47       */
    48      void setCurrentState(State state);
    49
    50      /**
    51       * Returns the value of the attribute with the specified key or
    52       * <code>null</code>if not found.
    53       *
    54       * @param key the key.
    55       * @return the value or <code>null</code>.
    56       */
    57      Object getAttribute(Object key);
    58
    59      /**
    60       * Sets the value of the attribute with the specified key.
    61       *
    62       * @param key the key.
    63       * @param value the value.
    64       */
    65      void setAttribute(Object key, Object value);
    66  }